api/urls.py
from django.urls import path
from api import views


app_name ="api"
urlpatterns = [
    
]

core/urls.py
from django.urls import path
from core import views


app_name ="core"


urlpatterns = [
    path('list/grantgoal/',views.ListGrantGoal.as_view(), name="gg_list"),
    path('create/grantgoal/',views.ListGrantGoal.as_view(), name="gg_create"),
    path('detail/grantgoal/<int:pk>/', views.DetailGrantGoal.as_view(), name= "gg_detail"),
    path('update/grantgoal/<int:pk>/', views.UpdateGrantGoal.as_view(), name= "gg_update"),
    path('delete/grantgoal/<int:pk>/', views.DeleteGrantGoal.as_view(), name= "gg_delete"),
]

cplaest/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('api/', include("api.urls")),
    path('core/', include("core.urls")),
    path('', include("home.urls")),
]

core/models.py
from django.db import models

from django.contrib.auth.models import User

from datetime import timedelta
from django.db.models.signals import post_save
from django.dispatch import receiver

# Create your models here.

#### GRANT GOAL ####

STATE_CHOICES = (
    ('Done', 'DN'),
    ('Doing', 'DG'),
    ('Not started', 'NS'),
)
class GrantGoal(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    gg_title = models.CharField(max_length=128, default="Generic Grant Goal Title")
    desciption = models.CharField(max_length=256, default="Generic Grant Goal Description")
    timestamp = models.DateField(auto_now_add=True)
    days_duration = models.IntegerField(default=7)
    final_date = models.DateField(auto_now_add=False,auto_now=False,blank=True,null=True)
    status = models.BooleanField(default=True)
    state = models.CharField(max_length=16, choices=STATE_CHOICES)
    sprint = models.IntegerField(default=1)
    slug = models.SlugField(max_length=16)

    def __str__(self):
        return self.gg_title


### SIGNALS
### post_save

@receiver(post_save, sender=GrantGoal)
def end_time_grantgoal(sender, instance, **kwargs):
    if instance.final_date is None or instance.final_date=='':
        instance.final_date = instance.timestamp + timedelta(days=instance.days_duration)
        instance.save()

### GOALS ####

### SUBGOALS ###

### ISSUES ###

core/forms.py
from django import forms
from .models import GrantGoal

class GrantGoalForm(forms.ModelForm):
    class Meta:
        model = GrantGoal
        fields = "__all__"
        exclude = ["timestamp", "final_date"]
        widgets = {
            "user": forms.Select(attrs={"type":"select","class":"form-select"}),
            "gg_title": forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Escribe el nombre del GrantGoal"}),
            "description": forms.Textarea(attrs={"type":"text", "class":"form-control", "rows":3, "placeholder":"Escribe la descripcion del GrantGoal"}),
            "days_duration": forms.NumberInput(attrs={"type":"number", "class":"form-control"}),
            "status": forms.CheckboxInput(attrs={"type":"checkbox", "class":"form-checkbox"}),
            "state": forms.Select(attrs={"type":"select","class":"form-select"}),
            "sprint":forms.NumberInput(attrs={"type":"number", "class":"form-control"}),
            "slug":forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Escribe el codigo del GrantGoal"}),
        }



class UpdateGrantGoalForm(forms.ModelForm):
    class Meta:
        model = GrantGoal
        fields = "__all__"
        exclude = ["timestamp", "final_date"]
        widgets = {
            "user": forms.Select(attrs={"type":"select","class":"form-select"}),
            "gg_title": forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Escribe el nombre del GrantGoal"}),
            "description": forms.Textarea(attrs={"type":"text", "class":"form-control", "rows":3, "placeholder":"Escribe la descripcion del GrantGoal"}),
            "days_duration": forms.NumberInput(attrs={"type":"number", "class":"form-control"}),
            "status": forms.CheckboxInput(attrs={"type":"checkbox", "class":"form-checkbox"}),
            "state": forms.Select(attrs={"type":"select","class":"form-select"}),
            "sprint":forms.NumberInput(attrs={"type":"number", "class":"form-control"}),
            "slug":forms.TextInput(attrs={"type":"text", "class":"form-control", "placeholder":"Escribe el codigo del GrantGoal"}),
        }

core/views.py
from django.shortcuts import render

from django.views import generic
from django.contrib.auth.mixins import LoginRequiredMixin

from django.urls import reverse_lazy
from .models import GrantGoal
from .forms import GrantGoalForm, UpdateGrantGoalForm
# Create your views here.

##### G R A N T G O A L C R U D #####

##Create
class CreateGrantGoal(LoginRequiredMixin, generic.CreateView):
    template_name = "core/gg_create.html"
    model = GrantGoal
    form_class = GrantGoalForm
    success_url = reverse_lazy("core:gg_list")
    login_url = reverse_lazy("home:index")


## Retrieve
#List GrantGoal
class ListGrantGoal(LoginRequiredMixin, generic.View):
    template_name = "core/gg_list.html"
    context = {}
    login_url = reverse_lazy("home:index")

    def get(self, request, *args, **kwargs):
        queryset = GrantGoal.objects.filter(status=True)
        self.context = {
            "grant_goals": queryset
        }
        return render(request, self.template_name, self.context)


#Detail
class DetailGrantGoal(LoginRequiredMixin, generic.DetailView):
    template_name = "core/gg_detail.html"
    model = GrantGoal
    login_url = reverse_lazy("home:index")


#Update
class UpdateGrantGoal(LoginRequiredMixin, generic.UpdateView):
    template_name = "core/gg_update.html"
    model = GrantGoal
    form_class = UpdateGrantGoalForm
    success_url = reverse_lazy("core:gg_list")
    login_url = reverse_lazy("home:index")


#Delete
class DeleteGrantGoal(LoginRequiredMixin, generic.DeleteView):
    template_name = "core/gg_delete.html"
    model = GrantGoal
    success_url = reverse_lazy("core:gg_list")
    login_url = reverse_lazy("home:index")

templates/core/gg_create.html
{% extends "base/base.html" %}

{% block title %}
  CREATE GRANT GOAL VIEW
{% endblock title %}

{% block content %}
    <form action="" method="post" class="form">
        {% csrf_token %}
        {{ form }}
        <button type="submit" class="btn btn-outline-success">Create GrantGoal</button>
        <a href="{% url 'core:gg_list' %}" class="btn btn-outline-warning">Cancel</a>
    </form>
{% endblock content %}

templates/core/gg_delete.html
{% extends "base/base.html" %}

{% block title %}
  DELETE GRANT GOAL VIEW
{% endblock title %}

{% block content %}
    <form action="" method="post">
        {% csrf_token %}
        ¿Realmente deseas Eliminar al GrantGoal: {{ object }}?
        <button type="submit" class="btn btn-outline-danger">Delete GrantGoal</button>
        <a href="{% url 'core:gg_list'%}" class="btn btn-outline-warning">Cancel</a>
    </form>
{% endblock content %}

templates/core/gg_detail.html
{% extends "base/base.html" %}

{% block title %}
  DETAIL GRANTGOAL VIEW
{% endblock title %}


{% block content %}
<div class="accordion" id="accordionExample">
    <div class="accordion-item">
      <h2 class="accordion-header" id="headingOne">
        <button class="accordion-button" type="button" data-bs-toggle="collapse" data-bs-target="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
            {{ object.gg_title }}
        </button>
      </h2>
      <div id="collapseOne" class="accordion-collapse collapse show" aria-labelledby="headingOne" data-bs-parent="#accordionExample">
        <div class="accordion-body">
          <strong>This is the grantgoal: {{ object.gg_title }} .</strong> <br>
          Grantgoal Description: {{ object.description }}
        </div>
      </div>
    </div>
    <div class="accordion-item">
      <h2 class="accordion-header" id="headingTwo">
        <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#collapseTwo" aria-expanded="false" aria-controls="collapseTwo">
          Date Data
        </button>
      </h2>
      <div id="collapseTwo" class="accordion-collapse collapse" aria-labelledby="headingTwo" data-bs-parent="#accordionExample">
        <div class="accordion-body">
          <strong>This is the timestamp {{ object.timestamp }} to grantgoal {{ object.gg_title }} </strong> with Duration {{ object.days_duration }} days, The Deadline grantgoal is: {{ object.final_date }}
        </div>
      </div>
    </div>
    <div class="accordion-item">
      <h2 class="accordion-header" id="headingThree">
        <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#collapseThree" aria-expanded="false" aria-controls="collapseThree">
          Status Grant Goal
        </button>
      </h2>
      <div id="collapseThree" class="accordion-collapse collapse" aria-labelledby="headingThree" data-bs-parent="#accordionExample">
        <div class="accordion-body">
          <strong>This is the status {{ object.status }} for the {{ object.gg_title }} </strong> Its state is: {{ object.state }}
        </div>
      </div>
    </div>
  </div>
  
  <a href="{% url 'core:gg_list' %}">back to list</a>
{% endblock content %}

templates/core/gg_list.html
{% extends 'base/base.html' %}

{% block title %} LIST GRANT GOAL VIEW {% endblock title %}

{% block content %}


    <a href="{% url 'core:gg_create' %}" class="btn btn-outline-success form-control">Create a New GrantGoal</a>
    <table class="table table-striped table-hover">
        <thead>
            <th>ID</th>
            <th>GG TITLE</th>
            <th>TIMESTAMP</th>
            <th>DAYS DURATION</th>
            <th>USER</th>
            <th></th>
            <th>ACTIONS</th>
            <th></th>
        </thead>
        <tbody>
            {% for gg in grant_goals %}
                <tr>
                    <td>{{ gg.id }}</td>
                    <td>{{ gg.gg_title }}</td>
                    <td>{{ gg.timestamp }}</td>
                    <td>{{ gg.days_duration }}</td>
                    <td>{{ gg.user }}</td>
                    <td><a href="{% url 'core:gg_detail' gg.id %}" class="btn btn-outline-info"> Detail </a></td>
                    <td><a href="{% url 'core:gg_update' gg.id %}" class="btn btn-outline-warning"> Update</a></td>
                    <td><a href="{% url 'core:gg_delete' gg.id %}" class="btn btn-outline-danger">Delete</a></td>
                </tr>
            {% endfor %}
        </tbody>
    </table>
   
{% endblock content %}

templates/core/gg_update.html
{% extends "base/base.html" %}

{% block title %}
  UPDATE GRANT GOAL VIEW
{% endblock title %}

{% block content %}
    <form action="" method="post" class="form">
        {% csrf_token %}
        {{ form }}
        <button type="submit" class="btn btn-outline-primary">Update GrantGoal</button>
        <a href="{% url 'core:gg_list' %}" class="btn btn-outline-warning">Cancel</a>
    </form>
{% endblock content %}